colorSelection = {}

function colorSelection.prerequisitesPresent(specializations)
  return true
end

function colorSelection:load(savegame)
  if self.configurations["baseColor"] ~= nil then
    colorSelection.changeColor(self, "baseColor")
  end;
  if self.configurations["designColor"] ~= nil then
    colorSelection.changeColor(self, "designColor")
  end;
  if self.configurations["rimColor"] ~= nil then
    colorSelection.changeColor(self, "rimColor")
  end;
end

function colorSelection:delete()
end

function colorSelection:readStream(streamId, connection)
end

function colorSelection:writeStream(streamId, connection)
end

function colorSelection:mouseEvent(posX, posY, isDown, isUp, button)
end

function colorSelection:keyEvent(unicode, sym, modifier, isDown)
end

function colorSelection:update(dt)
end

function colorSelection:updateTick(dt)
end

function colorSelection:draw()
end

function colorSelection.changeColor(self, configName)
  local configId = self.configurations[configName]
  if configId ~= nil then
    local item = StoreItemsUtil.storeItemsByXMLFilename[self.configFileName:lower()]
    local config = item.configurations[configName][configId]
    if config ~= nil then
      local color = config.color
      if color ~= nil then
        local r, g, b, a = unpack(color)
        local i = 0
        while true do
          local colorKey = string.format("vehicle.%sConfigurations.colorNode(%d)", configName, i)
          if not hasXMLProperty(self.xmlFile, colorKey) then
            break
          end
          local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, colorKey .. "#node"))
          local shaderParameters = getXMLString(self.xmlFile, colorKey .. "#shaderParameters")
          if node ~= nil and shaderParameters ~= nil then
            if getHasClassId(node, ClassIds.SHAPE) then
              local shaderParameters = Utils.splitString(" ", shaderParameters)
              local s = 1
              while true do
                if shaderParameters[s] == nil then
                  break
                end
                local _, _, _, m = getShaderParameter(node, shaderParameters[s])
                if Utils.getNoNil(getXMLBool(self.xmlFile, colorKey .. "#recursive"), false) then
                  Utils.setShaderParameterRec(node, shaderParameters[s], r, g, b, m)
                else
                  setShaderParameter(node, shaderParameters[s], r, g, b, m, false)
                end
                s = s + 1
              end
            else
              print("Warning: Could not set vehicle color to '" .. getName(node) .. "' because node is not a shape!")
            end
          end
          i = i + 1
        end
      end
    end
  end
end
